// Author.: Breno de Lima Sarmento
// Website: http://www.brels.net
// License: GNU/GPL
// Created: 19-sep-2009, 21h46
// Version: 19-sep-2009, 22h45 (0.01)

#include <stdio.h>
#include <windows.h>
#include <psapi.h>


char* ShowLastError()
{
    /* From MSDN */

    LPVOID lpMsgBuf;
    DWORD dw = GetLastError();

    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER |
        FORMAT_MESSAGE_FROM_SYSTEM |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        dw,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0, NULL );


    return (char*) lpMsgBuf;
    //MessageBox(HWND_DESKTOP, (char*) lpMsgBuf, "Erro", MB_OK | MB_ICONWARNING);
}

int main()
{

    /* From MSDN */
    // Get the list of process identifiers.

    HANDLE proc;
    DWORD aProcesses[1024], cbNeeded, cProcesses;
    unsigned int i;

    if ( !EnumProcesses( aProcesses, sizeof(aProcesses), &cbNeeded ) )
        return -1;

    // Calculate how many process identifiers were returned.

    cProcesses = cbNeeded / sizeof(DWORD);

    /* From Jesper in http://www.vistaheads.com/forums/microsoft-public-windows-vista-security/66178-openprocess-process_set_information-protected-processes.html */

TOKEN_PRIVILEGES tp;
LUID luid;

if ( !LookupPrivilegeValue(
NULL, // lookup privilege on local system
"SeDebugPrivilege", // privilege to lookup
&luid ) ) // receives LUID of privilege
{
 ShowLastError();
return FALSE;
}

tp.PrivilegeCount = 1;
tp.Privileges[0].Luid = luid;
tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;

// Enable the privilege or disable all privileges.
HANDLE currProc = GetCurrentProcess();
HANDLE procToken;
if(!OpenProcessToken(currProc,TOKEN_ADJUST_PRIVILEGES,&procToken))
{
    ShowLastError();
return -1;
}

if ( !AdjustTokenPrivileges(
procToken,
FALSE,
&tp,
sizeof(TOKEN_PRIVILEGES),
(PTOKEN_PRIVILEGES) NULL,
(PDWORD) NULL) )
{
    ShowLastError();
return FALSE;
}

CloseHandle(procToken);
CloseHandle(currProc);


    int cores = atoi(getenv("NUMBER_OF_PROCESSORS"));
    int mask = 0;
    for ( i = 0; i < cProcesses; i++ )
        if( aProcesses[i] != 0 )
        {
            proc = OpenProcess(PROCESS_ALL_ACCESS, FALSE, aProcesses[i]);
            if (!SetProcessAffinityMask(proc, 1 << mask))
                puts(ShowLastError());
            CloseHandle(proc);
            if (++mask >= cores) mask = 0;
        }

    return 0;
}
